
(compiletime (put 'putword 'PASS-1-MACRO 'pa1m-putword))

(compiletime (load fasl-decls))


(compiletime (remprop 'mkitem 'PASS-1-MACRO))
(de mkitem-cross (a b)
     (wplus2 (wshift a 26) (int2sys b)))
(compiletime
(put 'mkitem 'PASS-1-MACRO '(lambda(u) `(mkitem-cross ,(cadr u),(caddr u))))
)
 (copyd 'mkitem 'mkitem-cross)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         convex-FORMS.SL
% Description:  CONVEX lap support forms.
% Author:
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1988, Konrad Zuse Zentrum Berlin
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(compiletime (load fasl-decls))

(fluid '(*immediatequote))
(setq *immediatequote T)

(fluid '(symval symfnc symprp symnam ArgumentBlock))
 

% from

(de InumP (Expression)
  (and (fixp expression)
       (lessp expression (lshift 1  (compiler-constant 'infbitlength)))
       (geq   expression (lshift -1 (compiler-constant 'infbitlength)))))

(de  LapPlus2(x y) (Plus2 x y))
 
(de  LapLand(x y) (Land x y))
 
(de  LapLor(x y) (Lor x y))
 
(de  LapAdd1(x) (Add1 x ))
 
(de  LapSub1(x) (Sub1 x ))
 
(de  LapLsh(x y) (Lshift x y))
 
(compiletime
 (dm DefOpcode (a)
  (Prog (op args body lbody nm lnm form)
     (setq a (cdr a))
     (setq Op (first a))
     (setq args (second a))
     (setq Body (cddr a))
     (setq Body (subst 'effap 'effaval Body))
     (setq LBody (wrap-l Body))
     (setq LBody (subst 'effap 'effaval LBody))
     (setq LBody (subst 'shortlabelp 'shortlabelval LBody))
     (setq nm (intern(bldmsg "OP.%w" op)))
     (setq lnm (intern (bldmsg "%w-LTH" nm)))
     (setq form
     `(progn
        (de ,nm ,args
           (cond . ,(append body `((T(OpFailed ',op (list . ,args))))))
        )
        (de ,lnm ,args
           (cond . ,(append lbody `((T(OpFailed ',op (list . ,args))))))
        )
        (put ',op 'OpCodeFunction ',nm)
        (put ',op 'OpLengthFunction ',lnm)
     ))
     (return form)
))

(de wrap-l (u)
    (mapcar u (function (lambda (x) (list (car x)
                                          (cons (intern (bldmsg "%w-LTH"(caadr x)))
                                                (cdadr x)))))))
) %compiletime
 
(de OpFailed (op args)
  (printf "*** CONVEX op %p failed for arguments %p %n" op args)
  (op-k 0 0))
 
% functions testing and converting the parameters of instructions
 
(de indexedp(x)(eqcar x 'indexed))

(de RegP  (R) (eqCar R 'Reg))
 
(compiletime (ds Regp-inline (r) (eqcar r 'reg)))
 
(de AregP (R) (and (RegP-inline R) (get (second R) 'Areg)))
(put 'st 'areg 0)
 
(de Sregp (r)
  (prog (secr)
   (cond ((not (regp-inline r)) (return nil))
         ((numberp (setq secr (second r))) (return (sub1 secr))))
   (return (get secr 'sreg))))
 
(de VregP (R) (and (RegP-inline R) (get (second R) 'Vreg)))
 
 
 
(de stdimmediatep (r)
          (cond
               ((intp r) r)
               ((fixp r) `(fourbytes . ,r))
               ((and (immediatep r) (eqcar (cadr r) 'idloc)) r)
               ((immediatep r) `(fourbytes . ,r))
               ((eqcar r 'quote) `(fourbytes . ,r))
               (t NIL)))
 
(de stdimmediateval(r) (stdimmediatep r))
 
(de smallImmediatep (r)
   (cond ((immediatep r)(smallImmediatep (cadr r)))
         ((and (intp r) (geq r 0)(leq r 7)) r)
         ( t NIL)))
 
(de effap (r)
   % tests r for being an effective address
  (cond
        ((testaddress r) (cons 0 (testaddress r)))
        ((eqcar r 'INDEXED) (effap (cdr r)))
        ((and (idp r) (testaddress r)) (cons 0 (testaddress  r )))
        ((aregp r)(cons (aregp r) 0))
        ((atom r) nil)
        ((null (cdr r)) (effap (car r)))
        ((and (aregp (car r)) (idp (cadr r)) (testaddress (cadr r)))
         (cons (aregp (car r)) (testaddress(cadr r) )))
        ((and (aregp (car r)) (atom (cadr r)))
         (cons (aregp (car r)) (cadr r)))
        ((and (aregp (cadr r)) (idp (car r)) (testaddress (car r)))
         (cons (aregp (cadr r)) (testaddress(car r) )))
        ((and (aregp (cadr r)) (atom (car r)))
         (cons (aregp (cadr r)) (car r) ))
        (t nil)))
 
(de testAddress (u)
   (cond ((numberp u) nil)
         ((labelp u) `(fourbytes . ,u))
         ((atom u) nil)
         ((memq (car u)
          '($FLUID $GLOBAL FLUID GLOBAL EXTRAREG LABEL ENTRY INTERNALENTRY))
          `(fourbytes . ,u))
         ((eq (car u) 'IMMEDIATE) `(fourbytes . ,u))
         (T nil)))


 
(compiletime
(dm MakeRegs (u)
  (prog (i type liste)
      (setq i 0)
      (setq type (cadr u))
      (foreach x in (caddr u)
         do (setq liste (cons (list 'put (mkquote x) (mkquote type) i)
                              liste))
                   (setq i (add1 i)))
      (return (cons 'progn liste)))))
 
(MakeRegs Areg (A0 A1 A2 A3 A4 A5 A6 A7))
(MakeRegs Sreg (S0 S1 S2 S3 S4 S5 S6 S7))
(MakeRegs Vreg (V0 V1 V2 V3 V4 V5 V6 V7))
(put 'NIL 'sreg 5) (put 'NIL 'registername "s5")
(put 'T0 'areg 1) (put 't0 'registername "a1")
(put 'T1 'areg 2) (put 't1 'registername "a2") 
(put 'T2 'areg 3) (put 't2 'registername "a3") 
(put 'T3 'sreg 6) (put 't3 'registername "s6")
(put 'T4 'sreg 7) (put 't4 'registername "s7")
(put 'T5 'areg 4) (put 't5 'registername "a4")
(put 'ST 'areg 0) (put 'ST 'registername "sp")
(put 'FP 'areg 7) (put 'FP 'registername "fp")
(put 'NargReg 'sreg 7)(put 'NargReg 'registername "s7")
 
 
% Assembly Functions
 
(fluid '(CurrentOffset*))
 
% composition of instruction operands
 
(ds JKprt(j k)
  (wor (wshift (wand j 7) 3) (wand k 7)))
 
(ds IJKprt(i j k)
  (wor (wshift (wand i 7) 6) (wor (wshift (wand j 7) 3) (wand k 7))))
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the opcode format routines;
%
 
 
(de Op-i-j-k(Op i j k)
  (DepositHalfWord (wor (wshift (wand Op 2#1111111) 9)
                 (IJKprt i j k))))

(de Op-i-j-k-LTH(Op i j k) 2)
 
(de Op-j-k(Op j k)
  (DepositHalfWord (wor (wshift (wand Op 2#1111111111) 6)
                 (JKprt j k))))
 
(de Op-j-k-LTH(Op j k) 2)

(de Op-k(Op k)
  (DepositHalfWord (wor (wshift (wand Op 2#1111111111111) 3)
                  (wand k 7))))
 
(de Op-k-LTH(Op k) 2)
 

(de Op-immediate-000-k(Op N k)   % immediate with k-field = 0
 (prog (l)
  (setq l(or (and (eqcar n 'fourbytes) (setq N (cdr n)))
             (wgreaterp (neededbitsfor N) 16)))
  (DepositHalfWord (wor (wor (wshift (wand Op 2#1111111111) 7)
                       (if l 2#1000000 0000000))
                 (JKprt 000 k)))
  (if l (depositWordExpression (unimmediate N))
        (depositHalfwordExpression (unimmediate N))))) 
 
(de Op-immediate-000-k-LTH(Op N k)   % immediate with k-field = 0
 (prog (l)
  (setq l(or (and (eqcar n 'fourbytes) (setq N (cdr n)))
             (wgreaterp (neededbitsfor N) 16)))
  (return (if l 6 4))))



(de Op-immediate-001-k(Op N k)   % immediate with k-field = 1
 (prog (l)
  (setq l(or (and (eqcar n 'fourbytes) (setq N (cdr n)))
             (wgreaterp (neededbitsfor N) 16)))
  (DepositHalfWord (wor (wor (wshift (wand Op 2#1111111111) 7)
                      (if l 2#1000000 0000000))
                 (JKprt 001 k)))
  (if l (depositWordExpression (unimmediate N)) 
        (depositHalfwordExpression (unimmediate N)))))
 
(de Op-immediate-001-k-LTH(Op N k)   % immediate with k-field = 1
 (prog (l)
  (setq l(or (and (eqcar n 'fourbytes) (setq N (cdr n)))
             (wgreaterp (neededbitsfor N) 16)))
  (return (if l 6 4))))


 
(de Op-load(Op effa k)
 (prog (l j disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (DepositHalfWord (wor (wor (wshift (wand Op 2#1111111111) 7)
                      (if l 2#1000000 0000000))
                 (JKprt j k)))
  (if l (depositWordExpression (unimmediate disp)) 
        (depositHalfwordExpression (unimmediate disp)))))
 
(de unimmediate(x)
    (cond((not (eqcar x 'immediate))  x)
         ((numberp (setq x (cadr x))) x)
         ((idp x)`(mkitem ,id-tag (idloc , x)))
         ((codep x)`(mkitem ,code-tag , x))

  %     % for crosscomplation (reform quoted IDs)
  %   ((and (not (or (fixp x)(labelp x)(pairp x)))
  %         (eq (wand 31 (wshift x -26)) id-tag))
  %       (let ((tg (wand 31 (wshift x -26)))
  %             (inf (wand x 2#11111111111111111111)))
  %           `(mkitem ,tg (idloc ,(int2id inf)))))

         (t x)))

(de Op-load-LTH(Op effa k)
 (prog (l j disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (return  (if l 6 4))))


 
(de Op-store(Op k effa)
 (prog (l j disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (DepositHalfWord (wor (wor (wshift (wand Op 2#1111111111) 7)
                      (if l 2#1000000 0000000))
                 (JKprt j k)))
  (if l (DepositWordExpression disp) (DepositHalfWord disp))))
 
 
(de Op-store-LTH(Op k effa)
 (prog (l j disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (return (if l 6 4))))



(de Op-branch-short(Op n)
   (when (or (not(intp n))(wgreaterp n 128)(wlessp n -128))
         (stderror (list n "address too big for short jump format")))
   (DepositHalfWord (wor (wshift (wand Op 2#11111111) 8)
                  (wand n 2#11111111))))
 
(de Op-branch-short-LTH(Op n) 2)
 
(de Op-branch-long(Op effa)
 (prog (l j k disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq k 0)  % dummy here
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (DepositHalfWord (wor (wor (wshift (wand Op 2#1111111111) 7)
                      (if l 2#1000000 0000000))
                 (JKprt j k)))
  (if l (DepositWordExpression (unimmediate disp)) (DepositHalfWord disp))))
 
(de Op-branch-long-LTH(Op effa)
 (prog (l j k disp)
  (setq j (car effa)) (setq disp (cdr effa))
  (setq k 0)  % dummy here
  (setq l(or (and (eqcar disp 'fourbytes) (setq disp (cdr disp)))
             (wgreaterp (neededbitsfor disp) 16)))
  (return (if l 6 4))))



(fluid '(tow**15))
(setq tow**15 (expt 2 15))

(de neededbitsfor (n)
  (cond((and (intp n)(wlessp n tow**15) (wgreaterp n (minus tow**15))) 16)
       ((and (eqcar n 'immediate)(eqcar (cadr n) 'idloc)) 16)
       (t 32)))
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% Kludge of the year, just to avoid having IDLOC defined during compilation
 
% (CompileTime (fluid '(MACRO)))
%
% (setf MACRO 'MACRO)
%
%  (PutD 'IDLoc MACRO (function (lambda (x) (id2int (cadr x)))))
%
 
% Add the argument ref-name to the internal list if necessary.
%  This is written for clarity, instead of using nots and an and.
(de add-forward-internal (Ref-Name)
  (cond
   ((assoc Ref-Name labeloffsets*)
    nil)
   ((get Ref-Name 'internalentryoffset)
    nil)
   (t (setq forwardinternalreferences*
      (cons (cons Ref-Name currentoffset*)
            forwardinternalreferences*)))))
 
(de posintP (e) (and (fixp e) (wgeq e 0)))
 
(de MinusExpP (x)
  (and (fixp x) (minusp x)))
 
(de NotDone (x)
  (printF "*** CONVEX LAP %p not implemented yet ***%n" x)
  (Op-ijk 0 0))
 
(de CalculateAddress ()
   (when (and *writingfaslfile (wgeq (wplus2 currentoffset* 8)
                                     (wshift maxfasloffset* 2)))
         (when (not (add-fasl-space))
          (fatalerror "BPS exhausted during Faslout")))
   (wplus2 Codebase* CurrentOffset*))
 
% ------------------------------------------------------------
% Depositing Operations
% ------------------------------------------------------------

(de DepositByte (X)
(progn (putbyte (wPlus2 CodeBase* CurrentOffset*) 0 X)
    (UpdateBitTable 1 0)
    (setq CurrentOffset* (plus CurrentOffset* 1))))

(de DepositHalfWord (X)
(progn (puthalfword (wPlus2 CodeBase* CurrentOffset*) 0 X)
    (UpdateBitTable 2 0)
    (setq CurrentOffset* (plus CurrentOffset* 2))))

(de depositword (x)
  (putword (wplus2 codebase* currentoffset*) 0 x)
  (updatebittable 4 0)
  (setq currentoffset* (plus currentoffset* 4)))


(de deposit-relocated-word (offset)
  % Given an OFFSET from CODEBASE*, deposit a word containing the
  % absolute address of that offset.
  (putword (wplus2 codebase* currentoffset*)
           0
           (iplus2 offset (if *writingfaslfile 0 codebase*)))
  (updatebittable 4  reloc-word)
  (setq currentoffset* (plus currentoffset* 4)))


(de depositwordexpression (x)
  % Only limited expressions now handled
  (let (y)
    (cond
        % for crosscomplation
 %    ((not (or (fixp x)(labelp x)(pairp x)))
 %        (let ((tg (wand 31 (wshift x -26)))
 %              (inf (wand x 2#11111111111111111111)))
 %         (if (eq tg id-tag)
 %             (depositwordexpression `(mkitem ,tg (idloc ,(int2id inf))))
 %             (depositword x))))
      ((fixp x) (depositword (int2sys x)))
      ((labelp x) (deposit-relocated-word (labeloffset x)))
      ((equal (first x) 'internalentry) (DepositInternalEntry x))
      ((equal (first x) 'idloc) (depositwordidnumber (second x)))
      ((equal (first x) 'mkitem) (deposititem (second x) (third x)))
      ((equal (first x) 'entry) (depositentry x))
      ((memq (car x) '(fluid $fluid global $global)) (DepositFluid x))
      ((equal (first x) 'extrareg)(DepositExtraReg x))
      ((setq y (wconstevaluable x)) (depositword (int2sys y)))
      (t (stderror (bldmsg "Expression too complicated %r" x))))))
 

(de DepositInternalEntry (x)
       (let*((l (cadr x))
              y
             (offset (or (get l 'internalentryoffset)
                         (and (setq y (assoc l labeloffsets*))
                              (cdr y))) ))
         (if offset
             (deposit-relocated-word offset)
             (progn
                  (push (cons (cadr x) currentoffset* )
                         forwardinternalreferences*)  
                  (deposit-relocated-word 0))
            )))


(de DepositFluid (X)
    (DepositValueCellLocation (second X)))      % Defined in System-Faslin.Red

(de DepositExtraReg (X)
    (DepositExtraRegLocation (second X)))       % Defined in System-Faslin.Red

(de DepositEntry (X)
    (DepositFunctionCellLocation (second X)))   % Defined in System-Faslin.Red

(de depositforeignentry (x)
  (depositfunctioncelllocation (second x)))

(de depositwordidnumber (x)
  (cond
    ((or (not *writingfaslfile) (leq (idinf x) 128))
     (depositword (idinf X)))
    (t
      (putword (wplus2 codebase* currentoffset*) 0
               (makerelocword  reloc-id-number (findidnumber x)))
      (setq currentoffset* (plus currentoffset* 4))
      (updatebittable 4 reloc-word))))
 

(de DepositHalfWordExpression (X)
(prog (Y)
    (return (cond ((FixP X) (DepositHalfWord X))
    ((LabelP X)
    (progn (puthalfword (wPlus2 CodeBase* CurrentOffset*) 0
                    (IPlus2 (LabelOffset X)
                           (cond (*WritingFaslFile 0) (t CodeBase*))))
        (UpdateBitTable 2  reloc-right-half)
        (setq CurrentOffset* (plus CurrentOffset* 2))))
    
            ((and (equal (first X) 'Difference) (LabelP (second X))
            (LabelP (third X)))
           (DepositHalfWord (Difference (LabelOffset (second X))
                                           (LabelOffset (third X)))))
    ((equal (first X) 'IDLoc)
           (DepositHalfWordIDNumber (second X)))
    ((setq Y (WConstEvaluable X))
           (DepositHalfWord Y)) (t
    (StdError (BldMsg "Halfword expression too complicated %r" X)))))))
 
 
(de DepositItem (TagPart InfPart)
    (cond ((not *WritingFaslFile)
           (DepositWord
               (MkItem TagPart
                       (cond ((LabelP InfPart)
                              (wPlus2 CodeBase* (LabelOffset InfPart)))
                             ((codep Infpart)
                              (inf Infpart))
                             ((equal (first InfPart) 'IDLoc)
                              (IDInf (second InfPart)))
                             (t
                                (StdError
                                    (BldMsg "Unknown inf in MkItem %r"
                                            InfPart)))))))
          (t
             (progn (cond
                     ((codep Infpart)
                      (putword (wPlus2 CodeBase* CurrentOffset*) 0
                       (MkItem TagPart (inf InfPart))))
                     ((LabelP InfPart)      % RELOC_CODE_OFFSET = 0
                      (putword (wPlus2 CodeBase* CurrentOffset*) 0
                       (MkItem TagPart (LabelOffset InfPart))))
                     ((equal (first InfPart) 'IDLoc)
                      (putword (wPlus2 CodeBase* CurrentOffset*) 0
                       (MkItem TagPart
                        (MakeRelocInf  RELOC-ID-NUMBER
                          (FindIDNumber (second InfPart))))))
                     (t
                      (StdError (BldMsg "Unknown inf in MkItem %r"
                                 InfPart))))
              (setq CurrentOffset* (plus CurrentOffset* 4))
              (UpdateBitTable 4  RELOC-INF)))))
 

(de DepositHalfWordIDNumber (X)
    (cond ((or (not *WritingFaslFile) (LEQ (IDInf X) 128))
        (DepositHalfWord (IDInf X))) (t
    
    (progn (puthalfword (wplus2 codebase* currentoffset*) 0
                    (makerelochalfword  reloc-id-number (findidnumber x)))
        (setq currentoffset* (plus currentoffset* 2))
        (updatebittable 2 reloc-right-half)))))
 

(dskin "$pc/convex/convex-instr.sl")
