%
% LAP-TO-ASM.RED - LAP to assembler translator
%
% Author:      Eric Benson
%              Symbolic Computation Group
%              Computer Science Dept.
%              University of Utah
% Date:        13 August 1981
% Copyright (c) 1981 University of Utah
%

%  <PSL.COMP>LAP-TO-ASM.RED.5, 30-Apr-82 14:47:52, Edit by BENSON
%  Removed EVAL and IGNORE processing

%Imports '(PathIn);                     % kernel build files use PATHIN
                                        % Now included in Loadaux

(fluid '(*comp 
        *plap 
        dfprint* 
        charactersperword 
        addressingunitsperitem 
        addressingunitsperfunctioncell 
        inputsymfile* 
        outputsymfile* 
        codeout* 
        dataout* 
        initout* ; 
        codefilenameformat* 
        datafilenameformat* 
        initfilenameformat* 
        modulename* 
        uncompiledexpressions* 
        nextidnumber* 
        orderedidlist* 
        nilnumber* 
        *mainfound 
        *main 
        *declarebeforeuse 
        mainentrypointname* 
        entrypoints* 
        locallabels* 
        codeexternals* 
        codeexporteds* 
        dataexternals* 
        dataexporteds* 
        externaldeclarationformat* 
        exporteddeclarationformat* 
        labelformat* 
        fullwordformat* 
        doublefloatformat* 
        reservedatablockformat* 
        reservezeroblockformat* 
        undefinedfunctioncellinstructions* 
        definedfunctioncellformat* 
        printexpressionform* 
        printexpressionformpointer* 
        commentformat* 
        numericregisternames* 
        expressioncount* 
        asmopenparen* 
        asmcloseparen* 
        tobecompiledexpressions* 
        globaldatafilename*))

(fluid '(semic*))                       % global => fluid  oct 27, 1982  /imsss-jlm/
                        % for compatibility with faslout.red

(setq inputsymfile* "psl.sym")
(setq outputsymfile* "psl.sym")
(setq globaldatafilename* "global-data.red")
(setq initfilenameformat* "%w.init")

(de dfprintasm (u)                      %. Called by TOP-loop, DFPRINT!*
(prog (nam ty fn) 
        (cond ((atom u) (return nil))) 
        (setq fn (car u)) 
        (cond ((equal fn 'putd) (go db2))) 
        (cond ((not (memq fn '(de df dm dn))) (go db1))) 
        (setq nam (cadr u)) 
        (setq u (cons 'lambda (cddr u))) 
        (setq ty (cdr (assoc fn '((de . expr) 
                            (df . fexpr) 
                            (dm . macro) 
                            (dn . nexpr))))) 
db3 (cond ((equal ty 'macro) (prog (*comp) 
            (putd nam ty u))))          % Macros get defined now
        
        (cond ((flagp nam 'lose) (progn 
        (errorprintf "*** %r has not been defined, because it is flagged LOSE" 
                        nam) 
        (return nil)))) 
        (cond ((flagp ty 'compile) 
        (progn (put nam 'cfntype (list ty)) 
            (setq u (cons (list '*entry nam ty (length (cadr u))) 
                         (&comproc u nam))) 
            (cond (*plap (foreach x in u do (print x)))) 
            (cond ((neq ty 'expr) 
                (dfprintasm (list 'put (mkquote nam) ''type (mkquote ty))))) 
            (asmoutlap u))) (t 
        % should never happen
             (saveuncompiledexpression (list 'putd (mkquote nam) 
                                                  (mkquote ty) 
                                                  (mkquote u))))) 
        (return nil) 
db1                                     % Simple S-EXPRESSION, maybe EVAL it;
        (cond ((not (pairp u)) (return nil))) 
        (cond ((setq fn (get (car u) 'asmpreeval)) (return (apply fn (list u)))) 
        ((and (setq fn (getd (car u))) (equal (car fn) 'macro)) 
            (return (dfprintasm (apply (cdr fn) (list u)))))) 
        (saveuncompiledexpression u) 
        (return nil) 
db2 (setq nam (cadr u)) 
        (setq ty (caddr u)) 
        (setq fn (cadddr u)) 
        (cond ((eqcar nam 'quote) (progn (setq nam (cadr nam)) 
        (cond ((eqcar ty 'quote) (progn (setq ty (cadr ty)) 
        (cond ((and (pairp fn) (member (car fn) '(function quote))) (progn (setq fn (cadr fn)) 
        (cond ((memq ty '(expr fexpr macro nexpr)) 
        (progn (setq u fn) (go db3))))))))))))) 
        (go db1)))
   

(de asmpreevalloadtime (u) 
    (dfprintasm (cadr u)))              % remove LOADTIME

(put 'loadtime 'asmpreeval 'asmpreevalloadtime)

(de asmpreevalstartuptime (u) 
    (saveforcompilation (cadr u)))

(put 'startuptime 'asmpreeval 'asmpreevalstartuptime)

(de asmpreevalprogn (u) 
    (foreach x in (cdr u) do 
        (dfprintasm x)))

(put 'progn 'asmpreeval 'asmpreevalprogn)

(put 'wdeclare 'asmpreeval 'eval)       % do it now

(de asmpreevalsetq (u) 
(prog (x val) 
    (setq x (cadr u)) 
    (setq val (caddr u)) 
    (return (cond ((or (constantp val) (equal val t)) 
    (progn (findidnumber x) 
        (put x 'initialvalue val) nil)) 
        
    ((null val) 
    (progn (findidnumber x) 
        (remprop x 'initialvalue) 
        (flag (list x) 'nilinitialvalue) nil)) 
        
    ((eqcar val 'quote) 
    (progn (findidnumber x) 
        (setq val (cadr val)) 
        (cond ((null val) 
        (progn (remprop x 'initialvalue) 
            (flag (list x) 'nilinitialvalue))) (t 
        
            (put x 'initialvalue val))) nil)) 
        
    
                ((or (and (idp val) (get val 'initialvalue)) (flagp val 'nilinitialvalue)) 
    (progn (cond ((setq val (get val 'initialvalue)) 
            (put x 'initialvalue val)) (t 
        (flag (list x) 'nilinitialvalue))))) (t 
    (saveuncompiledexpression u))))))   % just check simple cases, else return


(put 'setq 'asmpreeval 'asmpreevalsetq)

(de asmpreevalputd (u) 
    (saveuncompiledexpression (checkforeasysharedentrypoints u)))

(de checkforeasysharedentrypoints (u) 
%
% looking for (PUTD (QUOTE name1) xxxx (CDR (GETD (QUOTE name2))))
%
(prog (nu nam exp) 
    (setq nu (cdr u)) 
    (setq nam (car nu)) 
    (cond ((equal (car nam) 'quote) (setq nam (cadr nam))) (t (return u))) 
    (setq nu (cdr nu)) 
    (setq exp (cadr nu)) 
    (cond ((not (equal (car exp) 'cdr)) (return u))) 
    (setq exp (cadr exp)) 
    (cond ((not (equal (car exp) 'getd)) (return u))) 
    (setq exp (cadr exp)) 
    (cond ((not (equal (car exp) 'quote)) (return u))) 
    (setq exp (cadr exp)) 
    (findidnumber nam) 
    (put nam 'entrypoint (findentrypoint exp)) 
    (cond ((not (equal (car nu) ''expr)) (return (list 'put ''type 
                                                           (car nu))))) 
    (return nil)))


(put 'putd 'asmpreeval 'asmpreevalputd)

(de asmpreevalfluidandglobal (u) 
(progn (cond ((eqcar (cadr u) 'quote) (flag (cadr (cadr u)) 'nilinitialvalue))) 
    (saveuncompiledexpression u)))

(put 'fluid 'asmpreeval 'asmpreevalfluidandglobal)
(put 'global 'asmpreeval 'asmpreevalfluidandglobal)

(commentoutcode (progn 
(fluid '(newfluids* newglobals*)) 

(de asmpreevalfluidandglobal (u) 
(prog (l) 
    (setq l (cadr u)) 
    (return (cond ((equal (car l) 'quote) 
    (progn (setq l (cadr l)) 
        (cond ((equal (car u) 'fluid) 
            (setq newfluids* (unionq newfluids* l))) (t 	% take union
        (setq newglobals* (unionq newglobals* l)))) 
        (flag l 'nilinitialvalue) nil)) (t 
        
    (saveuncompiledexpression u)))))) 


(put 'fluid 'asmpreeval 'asmpreevalfluidandglobal) 
(put 'global 'asmpreeval 'asmpreevalfluidandglobal) nil))


(de asmpreevallap (u) 
    (cond ((eqcar (cadr u) 'quote) (asmoutlap (cadr (cadr u)))) (t 
    (saveuncompiledexpression u))))

(put 'lap 'asmpreeval 'asmpreevallap)

(commentoutcode (progn 
(de initialput (nam ind val) 
(prog (l p) 
    (findidnumber nam) 
    (cond ((setq p (atsoc ind (setq l (get nam 'initialpropertylist)))) 
        (rplacd p val)) (t 
    (put nam 'initialpropertylist (cons (cons ind val) l)))))) 


(de initialremprop (nam ind) 
(prog (l) 
    (cond ((setq l (get nam 'initialpropertylist)) 
        (put nam 'initialpropertylist (delatqip ind l)))))) 


(de initialflag1 (nam ind) 
(prog (l p) 
    (findidnumber nam) 
    (cond ((not (memq ind (setq l (get nam 'initialpropertylist)))) 
        (put nam 'initialpropertylist (cons ind l)))))) 


(de initialremflag1 (nam ind) 
(prog (l) 
    (cond ((setq l (get nam 'initialpropertylist)) 
        (put nam 'initialpropertylist (delqip ind l)))))) 


(de asmpreevalput (u) 
(prog (nam ind val) 
    (setq nam (second u)) 
    (setq ind (third u)) 
    (setq val (fourth u)) 
    (cond ((and (eqcar nam 'quote) (eqcar ind 'quote) 
                (or (constantp val) (equal val t) (eqcar val 'quote))) 
        (initialput (second nam) (second ind) (cond ((eqcar val 'quote) 
                                                (second val)) (t val)))) (t 
    (saveuncompiledexpression u))))) 


(put 'put 'asmpreeval 'asmpreevalput) 

(de asmpreevalremprop (u) 
(prog (nam ind) 
    (setq nam (second u)) 
    (setq ind (third u)) 
    (cond ((and (eqcar nam 'quote) (eqcar ind 'quote)) 
        (initialremprop (second nam) (second ind))) (t 
    (saveuncompiledexpression u))))) 


(put 'remprop 'asmpreeval 'asmpreevalremprop) 

(de asmpreevaldeflist (u) 
(prog (dlist ind) 
    (setq dlist (second u)) 
    (setq ind (third u)) 
    (cond ((and (eqcar dlist 'quote) (eqcar ind 'quote)) 
    (progn (setq dlist (second dlist)) 
        (setq ind (second ind)) 
        (foreach x in dlist do (initialput (first x) ind (second x))))) (t 
    (saveuncompiledexpression u))))) 


(put 'deflist 'asmpreeval 'asmpreevaldeflist) 

(de asmpreevalflag (u) 
(prog (namelist ind) 
    (setq namelist (second u)) 
    (setq ind (third u)) 
    (cond ((and (eqcar namelist 'quote) (eqcar ind 'quote)) 
    (progn (setq ind (second ind)) 
        (foreach x in (second namelist) do 
            (initialflag1 x ind)))) (t 
    (saveuncompiledexpression u))))) 


(put 'flag 'asmpreeval 'asmpreevalflag) 

(de asmpreevalremflag (u) 
(prog (namelist ind) 
    (setq namelist (second u)) 
    (setq ind (third u)) 
    (cond ((and (eqcar namelist 'quote) (eqcar ind 'quote)) 
    (progn (setq ind (second ind)) 
        (foreach x in (second namelist) do 
            (initialremflag1 x ind)))) (t 
    (saveuncompiledexpression u))))) 


(put 'remflag 'asmpreeval 'asmpreevalremflag) 

(de asmpreevalglobal (u) 
(prog (namelist) 
    (setq namelist (second u)) 
    (cond ((eqcar namelist 'quote) 
        (foreach x in (second namelist) do 
            (initialput x 'type 'global))) (t 
    (saveuncompiledexpression u))))) 


(put 'global 'asmpreeval 'asmpreevalglobal) 

(de asmpreevalfluid (u) 
(prog (namelist) 
    (setq namelist (second u)) 
    (cond ((eqcar namelist 'quote) 
        (foreach x in (second namelist) do 
            (initialput x 'type 'fluid))) (t 
    (saveuncompiledexpression u))))) 


(put 'fluid 'asmpreeval 'asmpreevalfluid) 

(de asmpreevalunfluid (u) 
(prog (namelist) 
    (setq namelist (second u)) 
    (cond ((eqcar namelist 'quote) 
        (foreach x in (second namelist) do 
            (initialremprop x 'type))) (t 
    (saveuncompiledexpression u))))) 


(put 'unfluid 'asmpreeval 'asmpreevalunfluid) nil))


(de saveuncompiledexpression (u) 
    (cond ((pairp u) 
    (prog (oldout) 
        (setq oldout (wrs initout*)) 
        (print u) 
        (wrs oldout)))))
    

(setq tobecompiledexpressions* (cons nil nil))

(de saveforcompilation (u) 
    (cond ((or (atom u) (member u (car tobecompiledexpressions*))) nil) 
    ((equal (car u) 'progn) 
        (foreach x in (cdr u) do (saveforcompilation x))) (t 
    (tconc tobecompiledexpressions* u))))

(de asmout (fil) 
(prog (oldout) 
    (setq modulename* fil) 
    (prin2t "ASMOUT: IN files; or type in expressions") 
    (prin2t "When all done execute ASMEND;") 
    (setq codeout* (open (bldmsg codefilenameformat* modulename*) 'output)) 
    (setq oldout (wrs codeout*)) 
    (linelength 1000) 
    (wrs oldout) 
    (codefileheader) 
    (setq dataout* (open (bldmsg datafilenameformat* modulename*) 'output)) 
    (setq oldout (wrs dataout*)) 
    (linelength 1000) 
    (wrs oldout) 
    (datafileheader) 
    (setq initout* (open (bldmsg initfilenameformat* modulename*) 'output)) 
    (readsymfile) 
    (setq dfprint* 'dfprintasm) 
    (remd 'oldlap) 
    (putd 'oldlap 'expr (cdr (remd 'lap))) 
    (putd 'lap 'expr (cdr (getd 'asmoutlap))) 
    (setq *defn t) 
    (setq semic* '$)                    % to turn echo off for IN
    (cond ((not 
            (or (equal modulename* "main") *main)) (evin (list globaldatafilename*))))))


(de asmend nil 
(progn (off syslisp) 
    (cond (*mainfound 
    (progn (compileuncompiledexpressions) 
%       WriteInitFile();
        (initializesymboltable))) (t 
    (writesymfile))) 
    (codefiletrailer) 
    (close codeout*) 
    (datafiletrailer) 
    (close dataout*) 
    (close initout*) 
    (remd 'lap) 
    (putd 'lap 'expr (cdr (getd 'oldlap))) 
    (setq dfprint* nil) 
    (setq *defn nil)))

(flag '(asmend) 'ignore)
(definerop 'asmend nil (estat 'asmend))

(de compileuncompiledexpressions nil 
(progn (commentoutcode (progn (addfluidandglobaldecls) nil)) 
    (dfprintasm (list 'de 'initcode 'nil 
                        (cons 'progn (car tobecompiledexpressions*))))))

(commentoutcode (progn 
(de addfluidandglobaldecls nil 
(progn (saveuncompiledexpression (list 'global (mkquote newglobals*))) 
    (saveuncompiledexpression (list 'fluid (mkquote newfluids*))))) nil))


(de readsymfile nil 
    (lapin inputsymfile*))

(de writesymfile nil 
(prog (newout oldout) 
    (setq oldout (wrs (setq newout (open outputsymfile* 'output)))) 
    (print (list 'saveforcompilation 
               (mkquote (cons 'progn (car tobecompiledexpressions*))))) 
    (saveidlist) 
    (setqprint 'nextidnumber*) 
    (setqprint 'stringgensym*) 
    (mapobl (function putprintentryandsym)) 
    (wrs oldout) 
    (close newout)))



(commentoutcode (progn 
(de writeinitfile nil 
(prog (oldout newout) 
    (setq newout (open initfilename* 'output)) 
    (setq oldout (wrs newout)) 
    (foreach x in (car uncompiledexpressions*) do (printinit x)) 
    (close newout) 
    (wrs oldout))) 


(de printinit (x) 
    (cond ((eqcar x 'progn) 
        (foreach y in (cdr x) do (printinit y))) (t 
    (print x)))) nil))


(de saveidlist nil 
(progn (print (list 'setq 'orderedidlist* (mkquote (car orderedidlist*)))) 
    (print '(setq orderedidlist* 
                        (cons orderedidlist* (lastpair orderedidlist*))))))

(de setqprint (u) 
    (print (list 'setq u (mkquote (eval u)))))

(de putprint (x y z) 
    (print (list 'put (mkquote x) (mkquote y) (mkquote z))))

(de putprintentryandsym (x) 
(prog (y) 
    (cond ((setq y (get x 'entrypoint)) (putprint x 'entrypoint y))) 
    (cond ((setq y (get x 'idnumber)) 
        (putprint x 'idnumber y))) 
(commentoutcode (progn 
        (cond ((setq y (get x 'initialpropertylist)) 
            (putprint x 'initialpropertylist y))) nil)) 

    (cond ((setq y (get x 'initialvalue)) 
        (putprint x 'initialvalue y)) 
    ((flagp x 'nilinitialvalue) 
        (print (list 'flag (mkquote (list x)) ''nilinitialvalue)))) 
    (cond ((equal (get x 'scope) 'external) 
    (progn (putprint x 'scope 'external) 
        (putprint x 'asmsymbol (get x 'asmsymbol)) 
        (cond ((get x 'wvar) (putprint x 'wvar x)) 
        ((get x 'warray) (putprint x 'warray x)) 
        ((get x 'wstring) (putprint x 'wstring x)) 
        ((setq y (get x 'wconst)) (putprint x 'wconst y))))))))


(de findidnumber (u) 
(prog (i) 
    (return (cond ((leq (setq i (id2int u)) 128) i) 
    ((setq i (get u 'idnumber)) i) (t 
    
    (progn                              % don't include SETQ in call to PUT -- miscompiles
        (setq i nextidnumber*) 
        (put u 'idnumber i) 
        (setq orderedidlist* (tconc orderedidlist* u)) 
        (setq nextidnumber* (plus nextidnumber* 1)) 
        i))))))


(setq orderedidlist* (cons nil nil))
(setq nextidnumber* 129)

(de initializesymboltable nil 
(prog (maxsymbol) 
    (setq maxsymbol (get 'maxsymbols 'wconst)) 
    (cond ((lessp maxsymbol nextidnumber*) 
    (progn (errorprintf "*** MaxSymbols %r is too small; at least %r is needed" 
                                maxsymbol nextidnumber*) 
        (setq maxsymbol (plus nextidnumber* 100))))) 
    (flag '(nil) 'nilinitialvalue) 
    (put 't 'initialvalue 't) 
    (put '$eof$ 'initialvalue (int2id (get 'eof 'charconst))) 
    (put '$eol$ 'initialvalue '!
) 
    (setq nilnumber* (compileconstant nil)) 
    (dataalignfullword) 
%/ This is a BUG? M.L. G.
%/    for I := NextIDNumber!* step 1 until MaxSymbol do
%/      DataPrintFullWord NilNumber!*;
    (initializesymval) 
    (datareserveblock (plus (difference maxsymbol nextidnumber*) 1)) 
    (initializesymprp) 
    (datareserveblock (plus (difference maxsymbol nextidnumber*) 1)) 
%/ This is a BUG? M.L. G.
%/    for I := NextIDNumber!* step 1 until MaxSymbol do
%/      DataPrintFullWord NilNumber!*;
    (initializesymnam maxsymbol) 
    (initializesymfnc) 
    (datareservefunctioncellblock (plus (difference maxsymbol nextidnumber*) 1)) 
    (dataalignfullword) 
    (dataprintgloballabel (findgloballabel 'nextsymbol)) 
    (dataprintfullword nextidnumber*)))


(de initializesymprp nil 
(progn (commentoutcode (progn (initializeheap) nil)) 	% init prop lists
    (dataprintgloballabel (findgloballabel 'symprp)) 
    (for (from i 0 128 1) (do 
        (initsymprp1 (int2id i)))) 
    (foreach x in (car orderedidlist*) do 
        (initsymprp1 x))))

(de initsymprp1 (x) 
(progn 
(commentoutcode (progn 
    (dataprintfullword (cond ((setq x (get x 'initialpropertylist)) 
                           x) (t 
                      nilnumber*))) nil)) 

    (dataprintfullword nilnumber*)))

(commentoutcode (progn 
(de initializeheap nil 
(prog (l) 
    (dataprintgloballabel (findgloballabel 'heap)) 
    (for (from i 0 128 1) (do 
        (printpropertylist (int2id i)))) 
    (foreach x in (car orderedidlist*) do 
        (printpropertylist x)) 
    (setq l (get 'heapsize 'wconst)))) nil))



(de initializesymnam (maxsymbol) 
(progn (dataprintgloballabel (findgloballabel 'symnam)) 
    (for (from i 0 128 1) (do 
        (dataprintfullword (compileconstant (id2string (int2id i)))))) 
    (foreach idname in (car orderedidlist*) do 
        (dataprintfullword (compileconstant (id2string idname)))) 
    (setq maxsymbol (difference maxsymbol 1)) 
    (for (from i nextidnumber* maxsymbol 1) (do 
        (dataprintfullword (plus i 1)))) 
    (dataprintfullword 0)))

(de initializesymval nil 
(progn (dataprintgloballabel (findgloballabel 'symval)) 
    (for (from i 0 128 1) (do (initsymval1 (int2id i)))) 
    (foreach x in (car orderedidlist*) do (initsymval1 x))))

(de initsymval1 (x) 
(prog (val) 
    (return (dataprintfullword (cond ((setq val (get x 'initialvalue)) 
                                 (compileconstant val)) 
                             ((flagp x 'nilinitialvalue) 
                                 nilnumber*) (t 
                             (list 'mkitem (get 'unbound 'wconst) 
                                                (findidnumber x))))))))


(de initializesymfnc nil 
(progn (dataprintgloballabel (findgloballabel 'symfnc)) 
    (for (from i 0 128 1) (do (initsymfnc1 (int2id i)))) 
    (foreach x in (car orderedidlist*) do (initsymfnc1 x))))

(de initsymfnc1 (x) 
(prog (ep) 
    (setq ep (get x 'entrypoint)) 
    (cond ((null ep) (dataprintundefinedfunctioncell)) (t 
    (dataprintdefinedfunctioncell ep)))))


(de asmoutlap (u) 
(prog (locallabels* oldout) 
    (setq u (pass1lap u))               % Expand cmacros, quoted expressions
    (codeblockheader) 
    (setq oldout (wrs codeout*)) 
    (foreach x in u do (asmoutlap1 x)) 
    (wrs oldout) 
    (codeblocktrailer)))


(de asmoutlap1 (x) 
(prog (fn) 
    (return (cond ((stringp x) (printlabel x)) 
    ((atom x) (printlabel (findlocallabel x))) 
    ((setq fn (get (car x) 'asmpseudoop)) (apply fn (list x))) (t 
    
    % instruction output form is:
    % "tab" <opcode> [ "space" <operand> { "comma" <operand> } ] "newline"
    (progn (prin2 '! )                  % TAB
        (printopcode (car x)) 
        (setq x (cdr x)) 
        (cond ((not (null x)) 
        (progn (prin2 '! )              % SPACE
            (printoperand (car x)) 
            (foreach u in (cdr x) do 
            (progn (prin2 '!,)          % COMMA
                (printoperand u)))))) 
        (prin2 $eol$)))))))             % NEWLINE


(put '*entry 'asmpseudoop 'asmprintentry)

(de asmprintentry (x) 
(prog (y) 
    (printcomment x) 
    (setq x (cadr x)) 
    (setq y (findentrypoint x)) 
    (cond ((not (flagp x 'internalfunction)) (findidnumber x))) 
    (cond ((eq x mainentrypointname*) 
    (progn (setq *mainfound t) 
        (specialactionformainentrypoint))) (t 
    (codedeclareexporteduse y)))))
 

(de codedeclareexporteduse (y) 
  (cond (*declarebeforeuse 
        (progn (codedeclareexported y) 
            (printlabel y))) (t 
        
        (progn (printlabel y) 
            (codedeclareexported y)))))

(de findentrypoint (x) 
(prog (e) 
    (return (cond ((setq e (get x 'entrypoint)) e) 
    ((and (asmsymbolp x) (not (get x 'asmsymbol))) 
    (progn (put x 'entrypoint x) 
        x)) (t 
    
    (progn (setq e (stringgensym)) 
        (put x 'entrypoint e) 
        e))))))


(de asmpseudoprintfloat (x) 
    (printf doublefloatformat* (cadr x)))

(put 'float 'asmpseudoop 'asmpseudoprintfloat)

(de asmpseudoprintfullword (x) 
    (foreach y in (cdr x) do (printfullword y)))

(put 'fullword 'asmpseudoop 'asmpseudoprintfullword)

(de asmpseudoprintbyte (x) 
    (printbytelist (cdr x)))

(put 'byte 'asmpseudoop 'asmpseudoprintbyte)

(de asmpseudoprinthalfword (x) 
    (printhalfwordlist (cdr x)))

(put 'halfword 'asmpseudoop 'asmpseudoprinthalfword)

(de asmpseudoprintstring (x) 
    (printstring (cadr x)))

(put 'string 'asmpseudoop 'asmpseudoprintstring)

(de printoperand (x) 
    (cond ((stringp x) (prin2 x)) 
    ((numberp x) (printnumericoperand x)) 
    ((idp x) (prin2 (findlabel x))) (t 
    (prog (hd fn) 
        (setq hd (car x)) 
        (cond ((setq fn (get hd 'operandprintfunction)) 
            (apply fn (list x))) 
        ((and (setq fn (getd hd)) (equal (car fn) 'macro)) 
            (printoperand (apply (cdr fn) (list x)))) 
        ((setq fn (wconstevaluable x)) (printoperand fn)) (t 
        (printexpression x)))))))
    

(put 'reg 'operandprintfunction 'printregister)

(de printregister (x) 
(prog (nam) 
    (setq x (cadr x)) 
    (cond ((stringp x) (prin2 x)) 
    ((numberp x) (prin2 (getv numericregisternames* x))) 
    ((setq nam (registernamep x)) (prin2 nam)) (t 
    
    (progn (errorprintf "***** Unknown register %r" x) 
        (prin2 x))))))


(de registernamep (x) 
    (get x 'registername))

(de asmentry (x) 
    (printexpression 
    (list 'plus2 'symfnc 
                 (list 'times2 addressingunitsperfunctioncell 
                               (list 'idloc (cadr x))))))

(put 'entry 'operandprintfunction 'asmentry)

(de asminternalentry (x) 
    (prin2 (findentrypoint (cadr x))))

(put 'internalentry 'operandprintfunction 'asminternalentry)
(put 'internalentry 'asmexpressionfunction 'asminternalentry)

(dm extrareg (u) 
    (list 'plus2 '(warray argumentblock) 
                                             (times (difference (cadr u) (plus lastactualreg& 1)) addressingunitsperitem)))

(de asmsyslispvarsprint (x) 
    (prin2 (findgloballabel (cadr x))))

(deflist '((wvar asmsyslispvarsprint) (warray 
          asmsyslispvarsprint) (wstring 
          asmsyslispvarsprint)) 'operandprintfunction)

(deflist '((wvar asmsyslispvarsprint) (warray 
          asmsyslispvarsprint) (wstring 
          asmsyslispvarsprint)) 'asmexpressionfunction)

(de asmprintvaluecell (x) 
    (printexpression (list 'plus2 'symval 
                                 (list 'times addressingunitsperitem 
                                              (list 'idloc (cadr x))))))

(deflist '((fluid asmprintvaluecell) 
          ($fluid asmprintvaluecell) 
          (global asmprintvaluecell) 
          ($global asmprintvaluecell)) 'operandprintfunction)

% Redefinition of WDeclare for output to assembler file

% if either UpperBound or Initializer are NIL, they are considered to be
% unspecified.

(df wdeclare (u) 
    (foreach x in (cddr u) do (wdeclare1 (car x) (car u) (cadr u) (cadr x) (caddr x))))

(flag '(wdeclare) 'ignore)

(de wdeclare1 (name scope typ upperbound initializer) 
    (cond ((equal typ 'wconst) 
        (cond ((and (equal scope 'external) (not (get name 'wconst))) 
            (errorprintf "*** A value has not been defined for WConst %r" 
                                                                name)) (t 
        
        (progn (put name 'scope (cond ((equal scope 'exported) 'external) (t scope))) 
            (put name 'wconst (wconstreform initializer)))))) (t 
    
    (progn (put name typ name) 
        (cond ((equal scope 'external) 
        (progn (put name 'scope 'external) 
            (cond ((not (registernamep name)) 	% kludge to avoid declaring
            (progn (setq name (lookuporaddasmsymbol name)) 
                (datadeclareexternal name) 	% registers as variables
                (codedeclareexternal name)))))) (t 
        
        (progn (put name 'scope (cond ((equal scope 'exported) 'external) (t scope))) 
            (setq name (lookuporaddasmsymbol name)) 
            (cond (*declarebeforeuse (datadeclareexported name))) 
            (datainit name 
                      typ 
                      upperbound 
                      initializer) 
            (cond ((not *declarebeforeuse) (datadeclareexported name))) 
            (codedeclareexternal name))))))))

(de datainit (asmsymbol typ upperbound initializer) 
(progn (dataalignfullword) 
    (cond ((equal typ 'wvar) 
    (progn (cond (upperbound 
            (errorprintf "*** An UpperBound may not be specified for a WVar"))) 
        (setq initializer (cond (initializer (wconstreform initializer)) (t 0))) 
        (dataprintvar asmsymbol initializer))) (t 
    
    (progn (cond ((and upperbound initializer) 
            (errorprintf "*** Can't have both UpperBound and initializer")) 
        ((not (or upperbound initializer)) 
            (errorprintf "*** Must have either UpperBound or initializer")) 
        (upperbound 
            (dataprintblock asmsymbol (wconstreform upperbound) typ)) (t 
        
        (progn (setq initializer (cond ((stringp initializer) initializer) (t 
                                (wconstreformlis initializer)))) 
            (dataprintlist asmsymbol initializer typ)))))))))

(de wconstreform (u) 
(prog (x) 
    (return (cond ((or (fixp u) (stringp u)) u) 
    ((idp u) 
        (cond ((or (get u 'warray) (get u 'wstring)) u) 
        ((get u 'wvar) (list 'getmem u)) 
        ((setq x (get u 'wconst)) x) (t 
        (errorprintf "*** Unknown symbol %r in WConstReform" u)))) 
    ((pairp u) 
        (cond ((setq x (get (car u) 'wconstreformpseudo)) (apply x (list u))) 
        ((setq x (get (car u) 'dofn)) (cons x (wconstreformlis (cdr u)))) 
        ((macrop (car u)) (wconstreform (apply (cdr (getd (car u))) (list u)))) (t 
        (cons (car u) (wconstreformlis (cdr u)))))) (t 
    (errorprintf "*** Illegal expression %r in WConstReform" u))))))


(de wconstreformident (u) 
    u)

(put 'internalentry 'wconstreformpseudo 'wconstreformident)

(de wconstreformquote (u) 
    (compileconstant (cadr u)))

(put 'quote 'wconstreformpseudo 'wconstreformquote)

(de wconstreformlis (u) 
    (foreach x in u collect (wconstreform x)))

(de wconstreformloc (u)                 %. To handle &Foo[23]
(progn (setq u (wconstreform (cadr u))) 
    (cond ((neq (car u) 'getmem) 
        (errorprintf "*** Illegal constant addressing expression %r" 
                                (list 'loc u))) (t 
    (cadr u)))))

(put 'loc 'wconstreformpseudo 'wconstreformloc)

(de wconstreformidloc (u) 
    (findidnumber (cadr u)))

(put 'idloc 'wconstreformpseudo 'wconstreformidloc)

(de lookuporaddasmsymbol (u) 
(prog (x) 
    (cond ((not (setq x (get u 'asmsymbol))) (setq x (addasmsymbol u)))) 
    (return x)))


(de addasmsymbol (u) 
(prog (x) 
    (setq x (cond ((and (asmsymbolp u) (not (get u 'entrypoint))) u) (t 
         (stringgensym)))) 
    (put u 'asmsymbol x) 
    (return x)))


(de dataprintvar (name init) 
(prog (oldout) 
    (dataprintlabel name) 
    (setq oldout (wrs dataout*)) 
    (printfullword init) 
    (wrs oldout)))


(de dataprintblock (name siz typ) 
(progn (cond ((equal typ 'wstring) 
        (setq siz (list 'quotient (list 'plus2 siz (plus charactersperword 1)) 
                                    charactersperword))) (t 
    (setq siz (list 'plus2 siz 1)))) 
    (datareservezeroblock name siz)))

(de dataprintlist (nam init typ) 
(prog (oldout) 
    (dataprintlabel nam) 
    (setq oldout (wrs dataout*)) 
    (cond ((equal typ 'wstring) 
        (cond ((stringp init) 
        (progn (printfullword (size init)) 
            (printstring init))) (t 
        
        (progn (printfullword (difference (length init) 1)) 
            (printbytelist (append init '(0))))))) 
    
        ((stringp init) (prog (s) 
            (setq s (size init)) 
            (for (from i 0 s 1) (do 
                (printfullword (indx init i)))))) (t 
        (foreach x in init do 
            (printfullword x)))) 
    (wrs oldout)))


(de dataprintgloballabel (x) 
(progn (cond (*declarebeforeuse (datadeclareexported x))) 
    (dataprintlabel x) 
    (cond ((not *declarebeforeuse) (datadeclareexported x))) 
    (codedeclareexternal x)))


(de datadeclareexternal (x) 
    (cond ((not (or (member x dataexternals*) (member x dataexporteds*))) 
    (progn (setq dataexternals* (cons x dataexternals*)) 
        (dataprintf externaldeclarationformat* x x)))))

(de codedeclareexternal (x) 
    (cond ((not (or (member x codeexternals*) (member x codeexporteds*))) 
    (progn (setq codeexternals* (cons x codeexternals*)) 
        (codeprintf externaldeclarationformat* x x)))))

(de datadeclareexported (x) 
(progn (cond ((or (member x dataexternals*) (member x dataexporteds*)) 
        (errorprintf "***** %r multiply defined" x))) 
    (setq dataexporteds* (cons x dataexporteds*)) 
    (dataprintf exporteddeclarationformat* x x)))

(de codedeclareexported (x) 
(progn (cond ((or (member x codeexternals*) (member x codeexporteds*)) 
        (errorprintf "***** %r multiply defined" x))) 
    (setq codeexporteds* (cons x codeexporteds*)) 
    (codeprintf exporteddeclarationformat* x x)))

(de printlabel (x) 
    (printf labelformat* x x))

(de dataprintlabel (x) 
    (dataprintf labelformat* x x))

(de codeprintlabel (x) 
    (codeprintf labelformat* x x))

(de printcomment (x) 
    (printf commentformat* x))

(setq printexpressionform* (list 'printexpression (mkquote nil)))
(setq printexpressionformpointer* (cdadr printexpressionform*))

% Save some consing
% instead of list('PrintExpression, MkQuote X), reuse the same list structure

(de printfullword (x) 
(progn (rplaca printexpressionformpointer* x) 
    (printf fullwordformat* printexpressionform*)))

(de dataprintfullword (x) 
(progn (rplaca printexpressionformpointer* x) 
    (dataprintf fullwordformat* printexpressionform*)))

(de codeprintfullword (x) 
(progn (rplaca printexpressionformpointer* x) 
    (codeprintf fullwordformat* printexpressionform*)))

(de datareservezeroblock (nam x) 
(progn (rplaca printexpressionformpointer* 
           (list 'times2 addressingunitsperitem x)) 
    (dataprintf reservezeroblockformat* nam printexpressionform*)))

(de datareserveblock (x) 
(progn (rplaca printexpressionformpointer* 
           (list 'times2 addressingunitsperitem x)) 
    (dataprintf reservedatablockformat* printexpressionform*)))

(de datareservefunctioncellblock (x) 
(progn (rplaca printexpressionformpointer* 
           (list 'times2 addressingunitsperfunctioncell x)) 
    (dataprintf reservedatablockformat* printexpressionform*)))

(de dataprintundefinedfunctioncell nil 
(prog (oldout) 
    (setq oldout (wrs dataout*)) 
    (foreach x in undefinedfunctioncellinstructions* do 
        (asmoutlap1 x)) 
    (wrs oldout)))


(de dataprintdefinedfunctioncell (x) 
  (progn (datadeclareexternal x) 
    (dataprintf definedfunctioncellformat* x x)))
 % in case it's needed twice


(de dataprintbytelist (x) 
(prog (oldout) 
    (setq oldout (wrs dataout*)) 
    (printbytelist x) 
    (wrs oldout)))


(de dataprintexpression (x) 
(prog (oldout) 
    (setq oldout (wrs dataout*)) 
    (printexpression x) 
    (wrs oldout)))


(de codeprintexpression (x) 
(prog (oldout) 
    (setq oldout (wrs codeout*)) 
    (printexpression x) 
    (wrs oldout)))


(setq expressioncount* -1)

(de printexpression (x) 
((lambda (expressioncount*) 
(prog (hd tl fn) 
    (setq x (resolvewconstexpression x)) 
    (cond ((or (numberp x) (stringp x)) (prin2 x)) 
    ((idp x) (prin2 (findlabel x))) 
    ((atom x) 
    (progn (errorprintf "***** Oddity in expression %r" x) 
        (prin2 x))) (t 
    
    (progn (setq hd (car x)) 
        (setq tl (cdr x)) 
        (cond ((setq fn (get hd 'binaryasmop)) 
        (progn (cond ((greaterp expressioncount* 0) (prin2 asmopenparen*))) 
            (printexpression (car tl)) 
            (prin2 fn) 
            (printexpression (cadr tl)) 
            (cond ((greaterp expressioncount* 0) (prin2 asmcloseparen*))))) 
        ((setq fn (get hd 'unaryasmop)) 
        (progn (prin2 fn) 
            (printexpression (car tl)))) 
        ((setq fn (get hd 'asmexpressionformat)) 
            (apply 'printf (cons fn (foreach y in tl collect 
                                    (list 'printexpression (mkquote y)))))) 
        ((and (setq fn (getd hd)) (equal (car fn) 'macro)) 
            (printexpression (apply (cdr fn) (list x)))) 
        ((setq fn (get hd 'asmexpressionfunction)) 
            (apply fn (list x))) (t 
        
        (progn (errorprintf "***** Unknown expression %r" x) 
            (printf "*** Expression error %r ***" x))))))))) 
(plus expressioncount* 1)))

(de asmprintwconst (u) 
    (printexpression (cadr u)))

(put 'wconst 'asmexpressionfunction 'asmprintwconst)

(deflist '((plus2 !+) (wplus2 
          !+) 
          (difference !-) (wdifference 
          !-) 
          (times2 *) (wtimes2 
          *) 
          (quotient /) (wquotient 
          /)) 'binaryasmop)

(deflist '((minus !-) (wminus 
          !-)) 'unaryasmop)

(de compileconstant (x) 
(progn (setq x (buildconstant x)) 
    (cond ((null (cdr x)) (car x)) (t 
    
    (progn (cond (*declarebeforeuse (codedeclareexported (cadr x)))) 
        (asmoutlap (cdr x)) 
        (datadeclareexternal (cadr x)) 
        (cond ((not *declarebeforeuse) (codedeclareexported (cadr x)))) 
        (car x))))))

(commentoutcode (progn 
(de compileheapdata (x) 
(prog (y) 
    (setq x (buildconstant x)) 
    (return (cond ((null (cdr x)) (car x)) (t 
    
    (progn (setq y (wrs dataout*)) 
        (foreach z in (cdr x) do (asmoutlap1 z)) 
        (datadeclareexported (cadr x)) 
        (wrs y) 
        (car x))))))) nil))



(de dataprintstring (x) 
(prog (oldout) 
    (setq oldout (wrs dataout*)) 
    (printstring x) 
    (wrs oldout)))


(de findlabel (x) 
(prog (y) 
    (return (cond ((setq y (atsoc x locallabels*)) (cdr y)) 
    ((setq y (get x 'asmsymbol)) y) 
    ((setq y (get x 'wconst)) y) (t 
    (findlocallabel x))))))


(de findlocallabel (x) 
(prog (y) 
    (return (cond ((setq y (atsoc x locallabels*)) (cdr y)) (t 
    
    (progn (setq locallabels* (cons (cons x (setq y (stringgensym))) locallabels*)) 
        y))))))


(de findgloballabel (x) 
    (or (get x 'asmsymbol) (errorprintf "***** Undefined symbol %r" x)))

(de codeprintf (fmt a1 a2 a3 a4) 
(prog (oldout) 
    (setq oldout (wrs codeout*)) 
    (printf fmt a1 a2 a3 a4) 
    (wrs oldout)))


(de dataprintf (fmt a1 a2 a3 a4) 
(prog (oldout) 
    (setq oldout (wrs dataout*)) 
    (printf fmt a1 a2 a3 a4) 
    (wrs oldout)))


% Kludge of the year, just to avoid having IDLOC defined during compilation

(compiletime (fluid '(macro)))

(setq macro 'macro)

(putd 'idloc macro 
(function (lambda (x) 
    (findidnumber (cadr x)))))


