%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:SYS-SUPPORT.SL
% Description:  System specific kernel support functions.
% Author:       Brian Beach, Hewlett-Packard`CRC
% Created:      22-Feb-84
% Modified:     29-Jun-84 13:56:27 (RAM)
% Mode:         Lisp
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1989, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

(de continuableerror (x y z) (console-print-string y) (console-newline))

(on fast-integers)

(lap '((*entry PlantUnbound expr 1)
       
        (*alloc 0)
	(*move (reg 1) (reg t2))
	(*wshift (reg t2) 2)
	(*WPLUS2 (reg t2) (fluid SYMFNC))       
	(ldil (hi16 UndefinedFunctionInstruction) (reg t1))
        (ldw  (displacement  (reg sr0) (reg t1) 
		(lo16 UndefinedFunctionInstruction)) (reg t1))
	(*move (reg t1) (displacement (reg sr0) (reg t2) 0))
	(*EXIT 0)
    UndefinedFunctionInstruction
       (word "undefinedfunction")))


(lap '( (*entry PlantCodePointer expr 2)
        (*alloc 0)
	(*move (reg 1) (reg t2))
	(*wshift (reg t2) 2)
	(*WPLUS2 (reg t2) (fluid SYMFNC))       
	(depi 8 4 5 (reg 2))
	(*move (reg 2) (displacement (reg sr0) (reg t2) 0)) % and plant it
        (*EXIT 0)))


(lap '( (*entry PlantLambdaLink expr 1)
        (*alloc 0)
	(*move (reg 1) (reg t2))
	(*wshift (reg t2) 2)
	(*WPLUS2 (reg t2) (fluid SYMFNC))       
	(ldil (hi16 LambdaLinkInstruction) (reg t1))
        (ldw  (displacement (reg sr0) (reg t1) 
	        (lo16 LambdaLinkInstruction)) (reg t1))
	(*move (reg t1) (displacement (reg sr0) (reg t2) 0))
	(*EXIT 0)
    LambdaLinkInstruction
       (word "compiledcallinginterpreted")))


(lap '((*entry COMPILEDCALLINGINTERPRETED expr 0)
    (ldil
         (hi16 (plus2 SYMFNC (times2 4 (idloc compiledcallinginterpretedaux))))
	 (reg t4))
    (ldw (displacement (reg sr0) (reg t4)
         (lo16 (plus2 SYMFNC (times2 4 (idloc compiledcallinginterpretedaux)))))
	 (reg t4))
    (ble (displacement (reg sr5) (reg t4) 0)) (nop))) 
		% call aux without destroying t3

(lap '((*entry addressapply0 expr 1)
       (ble (displacement (reg sr5) (reg 1) 0)) (nop)))
  
(de bittable (baseaddress bitoffset)
  (field (ilsh (byte baseaddress (ilsh bitoffset -2))
               (idifference (itimes2 (field bitoffset 30 2) 2) 6))
         30 2))

   % to be redefined in nonkernel

(lap '((*entry undefinedfunction expr 1)
    (ldil (hi16 (plus2 SYMFNC (times2 4 (idloc undefinedfunctionaux))))
         (reg t4))
    (ldw (displacement (reg sr0)(reg t4)
         (lo16 (plus2 SYMFNC (times2 4 (idloc undefinedfunctionaux)))))
         (reg t4))
    (ble (displacement  (reg sr5) (reg t4) 0)) (nop)))
                  % call aux without destroying t3

(lap '((*entry undefinedfunctionaux expr 1)
       (*alloc 1)
       (*wplus2 (reg t2) 8000)
       (*move (reg t2) (frame 1))
       (*move (quote "Undefined function called: ") (reg 1))
       (*call console-print-string)
       (nop)
       (*move (frame 1) (reg t1))
       (*wshift (reg t1) 2)
       (*wplus2 (reg t1) (fluid symnam))
       (*move (displacement (reg sr0) (reg t1) 0) (reg 1))
       (*mkitem (reg 1) (wconst vector-tag))
       (*call console-print-string)
       (*call console-newline)
       (*move 0 (reg 1))
       (*call Exit-with-status)
       (*exit 1)))

(de kernel-fatal-error (string)
  (console-print-string (kernelstring2string "FATAL ERROR: "))
  (console-print-string string)
  (console-newline)
  (exit-with-status -1))

(off fast-integers)
% signalhandler must reside in kernel

(commentoutcode lap '((*entry signalhaendler expr 0)
%       We save the information which is in 'scratch' registers.
%
       (*move (reg 1) (fluid 88k-signumber))
       (*move (reg st) (reg 4))
       (*wplus2 (reg 4) 72)
       (*move (reg 4) (fluid 88k-sigcp))
       (*move (indexed (reg 4) 12) (reg 5))
       (*move (reg st) (fluid 88k-sigaddr))
       (*move (reg 5) (fluid 88k-sigpc))
  
%  Check whether LISP trap handling is appropriate now

       (*movex ($fluid *kernelmode) (reg 5))
       (*jumpnoteq (label goon) (reg 5) 'nil)
       (*jumpnoteq (label templab) (reg 1) (quote 2)) % interrupt
       (*movex ($fluid *bruch*) (reg 5))
       (*jumpeq    (label templab) (reg 5) 0)
%
% Now we have a 'weaponed' interrupt. This is used e.g. by gc to remain
% operable. Return Immediately and mark with a negative value in *bruch* !!
%
    goon
       (*move -17 (reg 5))
       (*movex (reg 5) ($fluid *bruch*))
       (*move 0 (reg 5))
       (*movex (reg 5) (fluid Mips-sigcp))
       (jmp!.n (reg returnaddr))
       (nop)
    templab
       (*move (fluid 88k-dumparray*) (reg 5))
       (*move (indexed (reg 4) 0) (reg t1))
       (*move (reg t1) (indexed (reg 5) 200))
       (*move (indexed (reg 4) 4) (reg t1))
       (*move (reg t1) (indexed (reg 5) 204))
       (*move (indexed (reg 4) 8) (reg t1))
       (*move (reg t1) (indexed (reg 5) 208))
       (*move (indexed (reg 4) 12) (reg t1))
       (*move (reg t1) (indexed (reg 5) 212))
       (*move (indexed (reg 4) 16) (reg t1))
       (*move (reg t1) (indexed (reg 5) 216))
       (*move (indexed (reg 4) 20) (reg t1))
       (*move (reg t1) (indexed (reg 5) 220))
       (*move (indexed (reg 4) 24) (reg t1))
       (*move (reg t1) (indexed (reg 5) 224))
       (*move (indexed (reg 4) 28) (reg t1))
       (*move (reg t1) (indexed (reg 5) 228))

       (*move 0 (reg 3))
      loop
       (*move (displacement (reg 2) (reg 3)) (reg t1))
       (*move (reg t1) (displacement (reg 5) (reg 3)))
       (*wplus2 (reg 3) 4)
       (*jumpwlessp (label loop) (reg 3) 129)
%
% Now we have a 'weaponed' interrupt. This is used e.g. by gc to remain
% operable. Return Immediately and mark with a negative value in *bruch* !!

%
         (*jcall signal-done)
))

 (de hugo () nil)

(compiletime (flag '(profil) 'foreignfunction))

(commentoutcode lap '((*entry unix-profile expr 4)
       (*alloc 1)
       (*link profil expr 4)

       (*move 0 (reg 1))
       (*exit 1)))

