%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           symflagc.sl
% Description:    counting flagp uses and gets with nil return value
%                 to be able to decide which should be symflags
% Author:         Winfried Neun   ZIB Berlin
% Created:        27-June-1987
% Mode:           Lisp
% Package:
% Status:         Experimental (Do Not Distribute)
%
% Copyright (c) 1987, Konrad Zuse Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% symflags are used in two different ways. For flags all property list
% activities are done via fast vector access. For get calls on symflags
% the NIL case is done first. If no entry is present in symflags vector
% no get call will take place.
% The property to be a SYMFLAG must be set at the very early beginning
% of compilation
% dont compile this source with symflags loaded !!
 
(fluid '(*getcounts* *cntgetnilcase* *flagcounts*))
 
(de &flagp& (a b)
   (prog (x y)
        (setq x (&old-flagp& a b))
        (setq y (atsoc b *flagcounts*))
        (if y (rplacd y (wplus2 (cdr y) 1))
              (setq *flagcounts* (cons (cons b 1) *flagcounts*)))
        (return x)))
 
(de &get& (a b)
   (prog (x y)
        (setq x (&old-get& a b))
        (setq y (atsoc b *getcounts*))
        (if y (rplacd y (wplus2 (cdr y) 1))
              (setq *getcounts* (cons (cons b 1) *getcounts*)))
        (when x (return x))
        (setq y (atsoc b *cntgetnilcase*))
        (if y (rplacd y (wplus2 (cdr y) 1))
              (setq *cntgetnilcase* (cons (cons b 1) *cntgetnilcase*)))
        (return nil)))
 
(when (funboundp '&old-get&) (copyd '&old-get& 'get)
                             (copyd 'get '&get&))
(console-print-string "get replaced")
 
(when (funboundp '&old-flagp&) (copyd '&old-flagp& 'flagp)
                             (copyd 'flagp '&flagp&))
