%
% Graphics Map File calls for Apollo PSL.
%
% Author:      John W. Peterson
%              Computer Science Dept.
%              University of Utah
% Date:        May 1986
%

% This implements the contents of GMF.INS.PAS, plus a handy goody at the
% end that just dumps the current bitmap.  This code makes some assumptions
% that apollo's doesn't.  

(de gmf_open(filename)
  (prog (status)
    (putarg 1 filename '(string))
    (putarg 2 (stringlength filename) '(integer16))
    (putarg 3 0 '(integer16))  % 0 = overwrite
    (cleararg 4)
    (cleararg 5)
    (syscall 'GMF_!$OPEN 5)
    (setf status (getarg 5 '(integer32) '(fixn)))
    (cond ((equal status 0)
	   (apolloResetStatus)
	   (getarg 4 '(integer16) '(Inum)) % Returned value
	  )
	  (T (apolloError status)))))

% Slightly bogus, this should really just call gmf_copy_plane...

(de gmf_copy_subplane( stream ptr x_dim y_dim words_per_line)
  (prog (status)
     (putarg 1 stream '(integer16))
     (putarg 2 -1 '(integer16))
     (putarg 3 100 '(integer16))
     (putarg 4 ptr '(integer32))
     (putarg 5 x_dim '(integer16))
     (putarg 6 y_dim '(integer16))
     (putarg 7 0 '(integer16)) 		% offsets, assume zero 
     (putarg 8 0 '(integer16)) 		% (should use GMF_COPY_PLANE)
     (putarg 9 words_per_line '(integer16))
     (cleararg 10)
     (syscall 'GMF_!$COPY_SUBPLANE 10)
     (setf status (getarg 10 '(integer32) '(fixn)))
     (cond ((equal status 0)
	    (apolloResetStatus)
	   )
	  (T (apolloError status)))))

(de gmf_close(stream)
   (prog (status)
      (putarg 1 stream '(integer16))
      (cleararg 2)
      (syscall 'GMF_!$CLOSE 2)
      (setf status (getarg 2 '(integer32) '(fixn)))
      (cond ((equal status 0)
 	     (apolloResetStatus)
	    )
	    (T (apolloError status)))))

(de write_current_bitmap(filename)
   (prog (gmf_stream gmf_ptr wpl x_size y_size)
     (setq gmf_stream (gmf_open filename))
     (setq gmf_ptr (first (gpr_inq_bitmap_pointer (gpr_inq_bitmap))))
     (setq wpl (second (gpr_inq_bitmap_pointer (gpr_inq_bitmap))))
     (setq x_size (first (first (gpr_inq_bitmap_dimensions (gpr_inq_bitmap)))))
     (setq y_size (rest (first (gpr_inq_bitmap_dimensions (gpr_inq_bitmap)))))

     (printf "Size %w %w%n" x_size y_size)
     (gmf_copy_subplane gmf_stream gmf_ptr x_size y_size wpl)
     (gmf_close gmf_stream)
   ))
