%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXU:FASTCONS.SL
% Description:  Faster versions for cons xcons and ncons avoiding alloc 
% Author:       Winfried Neun 
% Created:      25 June 1982 
% Modified:	
% Mode:         Lisp
%
% (c) Copyright 1991, Konrad-Zuse-Zentrum Berlin, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(if  (getd '!_slowcons) nil % must avoid reloading

 (copyd '!_slowcons 'cons))

 (lap '((*entry cons expr 2)
	  (*alloc 0)
	  (*move (global heaplast) (reg 3))
	  (*move (global heaptrapbound) (reg 4))
	  (*move (reg 3) (reg 5))
	  (*wplus2 (reg 5) 8)
          (*jumpwgeq (label callslow) (reg 5) (reg 4))
          (*move (reg 1) (memory (reg 3) 0))
	  (*move (reg 2) (memory (reg 3) 4))
	  (*move (reg 5) (global heaplast))
	  (*move (reg 3) (reg 1))
	  (*mkitem (reg 1) pair-tag)
          (*exit 0)
      callslow
	  (*linke 0 !_slowcons expr 2)))

 (lap '((*entry ncons expr 2)
	  (*alloc 0)
	  (*move (global heaplast) (reg 3))
	  (*move (global heaptrapbound) (reg 4))
	  (*move (reg 3) (reg 5))
	  (*wplus2 (reg 5) 8)
          (*jumpwgeq (label callslow) (reg 5) (reg 4))
          (*move (reg 1) (memory (reg 3) 0))
	  (*move (global nil) (memory (reg 3) 4))
	  (*move (reg 5) (global heaplast))
	  (*move (reg 3) (reg 1))
	  (*mkitem (reg 1) pair-tag)
          (*exit 0)
      callslow
	  (*move (global nil) (reg 2))
	  (*linke 0 !_slowcons expr 2)))

 (lap '((*entry xcons expr 2)
	  (*alloc 0)
	  (*move (global heaplast) (reg 3))
	  (*move (global heaptrapbound) (reg 4))
	  (*move (reg 3) (reg 5))
	  (*wplus2 (reg 5) 8)
          (*jumpwgeq (label callslow) (reg 5) (reg 4))
          (*move (reg 1) (memory (reg 3) 4))
	  (*move (reg 2) (memory (reg 3) 0))
	  (*move (reg 5) (global heaplast))
	  (*move (reg 3) (reg 1))
	  (*mkitem (reg 1) pair-tag)
          (*exit 0)
      callslow
	  (*move (reg 1) (reg 3))
          (*move (reg 2) (reg 1))
	  (*move (reg 3) (reg 2))
	  (*linke 0 !_slowcons expr 2)))
